北大 oj 1088 滑雪

问题描述:

Michael喜欢滑雪百这并不奇怪, 因为滑雪的确很刺激。可是为了获得速度,滑的区域必须向下倾斜,而且当你滑到坡底,你不得不再次走上坡或者等待升降机来载你。Michael想知道载一个区域中最长底滑坡。区域由一个二维数组给出。数组的每个数字代表点的高度。下面是一个例子

1  2  3  4 5

16 17 18 19 6

15 24 25 20 7

14 23 22 21 8

13 12 11 10 9

一个人可以从某个点滑向上下左右相邻四个点之一,当且仅当高度减小。在上面的例子中,一条可滑行的滑坡为24-17-16-1。当然25-24-23-...-3-2-1更长。事实上,这是最长的一条。

Input

输入的第一行表示区域的行数R和列数C(1 <= R,C <= 100)。下面是R行,每行有C个整数,代表高度h,0<=h<=10000。

Output

输出最长区域的长度。

Sample Input

5 5

1 2 3 4 5

16 17 18 19 6

15 24 25 20 7

14 23 22 21 8

13 12 11 10 9

Sample Output

25

http://wenku.baidu.com/view/4064ef970029bd64783e2cee.html?re=view这个课件对着个问题讲的很清楚,

先贴一下解这个题目的过程 最开始为了练习dfs,即使知道肯定要超时 ,还是写了:

#include<iostream>
#include<string.h>
using namespace std;
int R,C;
int  cnt[101][101];
int visited[101][101];
int Max,step;
int dic[4][2]= {{0,1},{1,0},{-1,0},{0,-1}};

void dfs(int x,int y)
{
    if(step>Max)
        Max=step;
    for(int k=0; k<4; k++)
    {
        int tx = x + dic[k][0];
        int ty = y + dic[k][1];
        if(tx >= 0 && tx < R && ty >= 0 && ty < C && !visited[tx][ty]&&cnt[tx][ty]<cnt[x][y])
        {
            step++;
            visited[x+dic[k][0]][y+dic[k][1]]=1;
            dfs(x+dic[k][0],y+dic[k][1]);
            visited[x+dic[k][0]][y+dic[k][1]]=0;
            step--;
        }
    }
    return ;
}

int main()
{
    while(cin>>R>>C)
    {
        int x,y;
        Max=0;
        memset(cnt,0,sizeof(cnt));
        for(int i=0; i<R; i++)
            for(int j=0; j<C; j++)
            {
                cin>>cnt[i][j];
            }
        for(x=0; x<R; x++)
            for(y=0; y<C; y++)
           {
                memset(visited,0,sizeof(visited));
                step=1;
                visited[x][y]=1;
                dfs(x,y);
                visited[x][y]=0;
            }
            cout<<Max<<endl;
    }
    return 0;
}

恰好的是,中午实验室看见迪神了  迅速的被他改成了bfs,结果还是超时,晚上我又把代码发给他 然后他做了下优化,减少了搜索路径 然后才过了,

他的代码:

#include <iostream>
#include <string.h>
#include <algorithm>
#include <queue>
#include <cstdio>
#include <cmath>
using namespace std;
int R,C;
int cnt[101][101];
int ret[101][101];
int vis[101][101];
int step;
int dic[4][2]= {{0,1},{1,0},{-1,0},{0,-1}};

int dfs(int x, int y)
{
    int res = 1;
    for(int i = 0;i < 4; ++i)
    {
        int tx = x + dic[i][0];
        int ty = y + dic[i][1];
        if(tx >=  0 && tx < R && ty >= 0 && ty < C && cnt[tx][ty] < cnt[x][y])
        {
            if(vis[tx][ty])
            {
                res = max(res, 1 + vis[tx][ty]);
            }
            else
            {
                res = max(res, 1 + dfs(tx, ty));
            }
        }
    }
    return vis[x][y] = res;
}

int main()
{
    while(cin>>R>>C)
    {
        int x = 0,y = 0;
        memset(cnt,0,sizeof(cnt));
        for(int i=0; i<R; i++)
            for(int j=0; j<C; j++)
            {
                cin>>cnt[i][j];
            }
        memset(vis, 0, sizeof(vis));
        int ans = 0;
        for(x=0; x< R; x++)
            for(y=0; y < C; y++)
            {
                if(!vis[x][y])
                {
                    dfs(x, y);
                }
            }
        for(int i = 0;i < R; ++i)
        {
            for(int j = 0;j < C; ++j)
            {
                ans = max(ans, vis[i][j]);
            }
        }
        printf("%d\n", ans);
    }
    return 0;
}

接下来 是我的代码:这两个代码的总体思想一样,求出求出每个点出发的最大滑行距离,并且某个点出发的最大滑行距离等于下一个可以走的点的最大滑行距离+1,遇到访问过的结点 直接就可以利用了 避免了重复搜索。

#include<iostream>
#include<string.h>
using namespace std;
int R,C;
int  cnt[101][101];
int visited[101][101];
int Max,result;
int dic[4][2]= {{0,1},{1,0},{-1,0},{0,-1}};

int  dfs(int x,int y)
{
    int result=1,temp;
    if(visited[x][y])
        return visited[x][y];
    for(int k=0; k<4; k++)
    {
        int tx = x + dic[k][0];
        int ty = y + dic[k][1];
        if(tx >=  0 && tx < R && ty >= 0 && ty < C && cnt[tx][ty] < cnt[x][y])
        {
            result = max(result,dfs(tx,ty));
            visited[x][y]=visited[x][y]<result?result+1:visited[x][y];

        }
    }

    return visited[x][y];
}

int main()
{
    while(cin>>R>>C)
    {
        int x,y;

        for(int i=0; i<R; i++)
            for(int j=0; j<C; j++)
            {
                cin>>cnt[i][j];
            }
        for(int k=0; k<R; k++)
            for(int d=0; d<C; d++)
                visited[k][d]=0;
        for(int i=0; i<R; i++)
            for(int j=0; j<C; j++)
            {

                dfs(i,j);
            }

        int ans=1;
        for(int i = 0; i < R; ++i)
        {
            for(int j = 0; j < C; ++j)
            {
                ans=max(ans,visited[i][j]);
            }
        }
        cout<<ans<<endl;
    }
    return 0;
}
时间: 2024-10-09 23:07:44

北大 oj 1088 滑雪的相关文章

hdu 1088 滑雪

果然书要结合题来看才有效果 通过这题对记忆化搜索有了初步的理解 碰到没有访问过的点 进行搜索 之后记录下该点能滑出的最远距离 碰到搜索过的点 直接加上 dp[i] 就可以了 #include<stdio.h> #include<string.h> #include<math.h> #include<iostream> #include<algorithm> #include<queue> #include<stack> #

POJ 1088 滑雪 记忆化优化题解

本题有人写是DP,不过和DP还是有点差别的,应该主要是记忆化 Momoization 算法. 思路就是递归,然后在递归的过程把计算的结果记录起来,以便后面使用. 很经典的搜索题目,这种方法很多题目考到的. 关键还是如何把代码写清晰工整了,O(∩_∩)O~. #include <stdio.h> const int MAX_N = 101; int R, C; int arr[MAX_N][MAX_N]; int tbl[MAX_N][MAX_N]; inline int max(int a,

poj 1088 滑雪

http://poj.org/problem?id=1088 1 #include <cstdio> 2 #include <cstring> 3 #include <algorithm> 4 using namespace std; 5 6 int g[200][200]; 7 int dp[200][200]; 8 int r,c; 9 int dir[4][2]={{1,0},{-1,0},{0,1},{0,-1}}; 10 int max1=-1; 11 12

[ACM] poj 1088 滑雪 (记忆化搜索DFS)

求n*m网格内矩形的数目[ACM] poj 1088 滑雪 (记忆化搜索DFS),布布扣,bubuko.com

poj 1088 滑雪 【记忆化搜索】+【DFS】

策略:如题 题目链接:http://poj.org/problem?id=1088 代码: #include<stdio.h> #include<string.h> int map[105][105], dp[105][105], n, m; const int dir[4][2] = {0, 1, 1, 0, 0, -1, -1, 0}; //四个方向 int limit(int x, int y) //判断是不是越界了 { if(x<1||x>n||y<1||

百练 1088 滑雪

“人人为我”的解法: dp[i][j]表示坐标为(i,j)的点开始下滑的最大长度. 则dp[i][j]为(i,j)周围四个点中比(i,j)低,且最大长度最大再加一的值 用结构体来储存一个点的坐标和高度,这样按高度从小到大排完序以后还不会丢失坐标的值 从小到大遍历所有的点,经过一个点(i,j)时,用递推公式求L(i,j). 一个小技巧: 将矩阵height四周的值赋值为INF,你可以想想这是滑雪场四周非常非常高的围墙. 这样就避免了数组越界的判断,而且不会影响正确结果(因为我们找的是滑雪场内部的最

POJ 1088 滑雪 (动规)

滑雪 Time Limit: 1000MS Memory Limit: 65536K Total Submissions: 75664 Accepted: 28044 Description Michael喜欢滑雪百这并不奇怪, 因为滑雪的确很刺激.可是为了获得速度,滑的区域必须向下倾斜,而且当你滑到坡底,你不得不再次走上坡或者等待升降机来载你.Michael想知道载一个区域中最长底滑坡.区域由一个二维数组给出.数组的每个数字代表点的高度.下面是一个例子 1 2 3 4 5 16 17 18 1

POJ 1088 滑雪(记忆化搜索)

滑雪 Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 92384   Accepted: 34948 Description Michael喜欢滑雪百这并不奇怪, 因为滑雪的确很刺激.可是为了获得速度,滑的区域必须向下倾斜,而且当你滑到坡底,你不得不再次走上坡或者等待升降机来载你.Michael想知道载一个区域中最长底滑坡.区域由一个二维数组给出.数组的每个数字代表点的高度.下面是一个例子 1 2 3 4 5 16 17

poj 1088 滑雪(区间dp+记忆化搜索)

题目链接:http://poj.org/problem?id=1088 思路分析: 1>状态定义:状态dp[i][j]表示在位置map[i][j]可以滑雪的最长区域长度: 2>状态转移方程:由于由位置[i, j]只能向四个方向移动,所以子问题最多有四个:所以dp[i][j]为其邻域可以滑雪的最大区域长度加上从该位置滑到邻域的长度,即1: 代码如下: #include <cstdio> #include <iostream> #include <algorithm&